'''Game main module.

Contains the entry point used by the run_game.py script.
'''

from concepts.geometry import *

from river.gui import *
from river.scenarios.freeplay import *
from river.scenarios.tutorial import *
from river.scenarios.diwine import *
from river.scenarios.despair import *

from ui.components import *

import os


def main(data_dir):
    Component.set_font(os.path.join(data_dir, 'FreeSans'), 14)
    Component.set_logo(os.path.join(data_dir, 'Twisted.gif'))
    
    size   = Vector(1024, 768)
    window = RiverWindow(size, [[Tutorial], [Diwine, Despair, Battle],
                                [FreePlay]],
                         os.path.join(data_dir, 'River.jpg'),
                         os.path.join(data_dir, 'Icon.gif'))
    
    window.do_events()
        