'''Ah, sweet sleep!'''

from concepts.color import *

from _base import *
from move import *

import random


class Sleep(ProgressingAction):
    def __init__(self, person):
        super(Sleep, self).__init__(person)
        
        self._progress = 0.0
    
    def speed(self):
        return 0.01
    
    def good(self):
        return self.person().backpack()
    
    def progress(self):
        return self._progress
    
    def base_energy(self):
        if self.person().is_inside(self.person().home()):
            return 0.008
        else:
            return 0.003
    
    def progress_added(self):
        energy = self.base_energy()
        
        self.person().energy().add(0.5 * energy + energy * random.random())
        self.person().happiness().add(self.base_energy() - 0.006)


class GoAndSleep(DistantPlan):
    def __init__(self, person, target):
        super(GoAndSleep, self).__init__(person)
        
        self._has_slept = False
        
        self.set_route(person.route_to(target))
    
    def color(self):
        return Color(255, 0, 128)        
    
    def has_slept(self):
        return self._has_slept
    
    def will_sleep(self):
        self._has_slept= True
        
    def next_action(self):
        if self.has_slept():
            return None
        
        action = self.next_route_action()
        
        if action is not None:
            return action
        
        self.will_sleep()
        
        return Sleep(self.person())
