'''The attributes of people: mind, body and spirit.'''

from concepts.color import *

import random


class Attributes(object):
    def __init__(self):
        potential = random.randint(10, 20) + random.randint(10, 20)
        mind      = random.randint(1, 5) + random.randint(1, 5)
        body      = random.randint(1, 5) + random.randint(1, 5)
        spirit    = random.randint(1, 5) + random.randint(1, 5)
        total     = mind + body + spirit
        factor    = float(potential) / float(total)
        
        self._mind   = Mind(int(mind * factor))
        self._body   = Body(int(body * factor))
        self._spirit = Spirit(int(spirit * factor))
        
    def mind(self):
        return self._mind
    
    def body(self):
        return self._body
    
    def spirit(self):
        return self._spirit
    
    def total(self):
        return self.mind() + self.body() + self.spirit()
    
    def advancement_chance(self):
        return 0.01 / self.total()
    
    def change(self, delta):
        self._mind   = Mind(  min(25, max(1, self.mind()   + delta)))
        self._body   = Body(  min(25, max(1, self.body()   + delta)))
        self._spirit = Spirit(min(25, max(1, self.spirit() + delta)))
        
    def advance(self, job):
        total  = job.total_weights()
        number = random.randint(1, total)
        color  = Color(128, 255, 196)
        p      = '%s\'s' % job.person().name()
        
        if number <= job.body_weight():
            if self._body >= 25:
                return

            self._body += 1            
            job.person().city().log('%s body attribute increases to %d!' %
                                    (p, self.body()), color)
        elif number <= job.body_weight() + job.mind_weight():
            if self._mind >= 25:
                return

            self._mind += 1
            job.person().city().log('%s mind attribute increases to %d!' %
                                    (p, self.mind()), color)
        else:
            if self._spirit >= 25:
                return

            self._spirit += 1
            job.person().city().log('%s spirit attribute increases to %d!' %
                                    (p, self.spirit()), color)
            
        
class Attribute(int):
    def __init__(self, score):
        self._score = score

class Mind(Attribute):
    pass


class Body(Attribute):
    pass


class Spirit(Attribute):
    pass
