'''Basic Buttons.'''

from concepts.color import *

from ui.components import *


class RiverButton(Button):
    def __init__(self, area):
        super(RiverButton, self).__init__(area, Color(255, 255, 255),
                                          Color(64, 64, 216))    
        
    
            
class CommandButton(RiverButton):
    def __init__(self, area, panel, text, command, small = True,
                 immediate = False):
        super(CommandButton, self).__init__(area)
        
        self._panel     = panel
        self._text      = text
        self._command   = command
        self._small     = small
        self._immediate = immediate
        
    def panel(self):
        return self._panel
    
    def text(self):
        if callable(self._text):
            return self._text()
        else:
            return self._text
    
    def command(self):
        return self._command
    
    def small(self):
        return self._small
    
    def immediate(self):
        return self._immediate
    
    def do_click(self, vector):
        if self.immediate():
            self.command()()
        else:
            self.panel().do_event(self.command())
        
    def render_contents(self, renderer):
        if self.small():
            size = renderer.small_font_size() - 2
        else:
            size = renderer.font_size()
            
        renderer.draw_text(self.text(), Vector(4, (self.client_area().extent().y() -
                                                   size) / 2),
                           Color(255, 255, 255),
                           self.client_area().extent().x() - 8, True,
                           self.small())
        
