'''The farming industry.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *


class Farm(Building):
    def __init__(self, city, tile):
        super(Farm, self).__init__(city, tile, [Farming(self), Farming(self)])
    
    @classmethod
    def name(cls):
        return 'Farm'
        
    @classmethod
    def size(self):
        return 3
    
    @classmethod
    def cost(self):
        return [Wood(4), Stone(2)]
    
    @classmethod
    def color(self):
        return Color(192, 192, 0)


Building.add_type(Farm, 'industry', 1)


class Farming(Job):
    def __init__(self, farm):
        super(Farming, self).__init__(farm)
    
    def title(self):
        return 'Farmer'
    
    def color(self):
        return Color(255, 255, 0)
    
    def body_weight(self):
        return 2
    
    def mind_weight(self):
        return 1
    
    def spirit_weight(self):
        return 0
    
    def work_done(self):
        self.spawn(Wheat, 2, 6)
    
    def work_speed(self):
        return 0.005
