'''Growing and processing iron. :-)'''

from river.building import *
from river.actions.jobs import *
from river.goods import *


class Oven(ProcessingBuilding):
    def __init__(self, city, tile):
        super(Oven, self).__init__(city, tile, [Charcoaller(self)], [Wood(20)])
    
    @classmethod
    def name(cls):
        return 'Oven'
        
    @classmethod
    def size(self):
        return 2
    
    @classmethod
    def cost(self):
        return [Stone(25)]
    
    @classmethod
    def color(self):
        return Color(128, 64, 64)


Building.add_type(Oven, 'processing', 3)


class Charcoaller(ProcessingJob):
    def __init__(self, oven):
        super(Charcoaller, self).__init__(oven)
    
    def title(self):
        return 'Charcoaller'
    
    def color(self):
        return Color(128, 64, 64)
    
    def body_weight(self):
        return 1
    
    def mind_weight(self):
        return 0
    
    def spirit_weight(self):
        return 0
    
    def work_completly_done(self):
        self.spawn(Coal, 1, 3)
    
    def base_work_speed(self):
        return 0.001


class Furnace(ProcessingBuilding):
    def __init__(self, city, tile):
        super(Furnace, self).__init__(city, tile, [Smelter(self)],
                                      [Coal(5), Ore(5)])
    
    @classmethod
    def name(cls):
        return 'Furnace'
        
    @classmethod
    def size(self):
        return 2
    
    @classmethod
    def cost(self):
        return [Wood(10), Stone(15)]
    
    @classmethod
    def color(self):
        return Color(64, 48, 48)


class Smelter(ProcessingJob):
    def __init__(self, furnace):
        super(Smelter, self).__init__(furnace)
    
    def title(self):
        return 'Smelter'
    
    def color(self):
        return Color(96, 72, 48)
    
    def body_weight(self):
        return 1
    
    def mind_weight(self):
        return 0
    
    def spirit_weight(self):
        return 0
    
    def work_completly_done(self):
        self.spawn(Iron, 1, 2)
    
    def base_work_speed(self):
        return 0.005


Building.add_type(Furnace, 'processing', 4)
