'''The dwarf industry.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *
from river.terrain import *


class Mine(Building):
    def __init__(self, city, tile):
        super(Mine, self).__init__(city, tile, [Mining(self)])
    
    @classmethod
    def name(cls):
        return 'Mine'
        
    @classmethod
    def size(self):
        return 1
    
    @classmethod
    def color(self):
        return Color(72, 48, 0)
    
    @classmethod
    def cost(self):
        return [Wood(20), Stone(5)]
            
    @classmethod
    def built_on(self):
        return [Mountain, MagicalMountain]


Building.add_type(Mine, 'industry', 4)


class Mining(Job):
    def __init__(self, mine):
        super(Mining, self).__init__(mine)
    
    def title(self):
        return 'Miner'
    
    def color(self):
        return Color(48, 48, 48)
    
    def body_weight(self):
        return 1
    
    def mind_weight(self):
        return 0
    
    def spirit_weight(self):
        return 0
    
    def work_done(self):
        self.spawn(self.person().tile().terrain().resource(), 1, 2)
    
    def work_speed(self):
        return 0.001
