'''The quarrying industry.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *
from river.terrain import *


class Quarry(Building):
    def __init__(self, city, tile):
        super(Quarry, self).__init__(city, tile, [Quarrying(self)])
    
    @classmethod
    def name(cls):
        return 'Quarry'
        
    @classmethod
    def size(self):
        return 2
    
    @classmethod
    def color(self):
        return Color(216, 192, 192)
    
    @classmethod
    def cost(self):
        return [Wood(10)]
            
    @classmethod
    def built_on(self):
        return [Rock, MarbleRock]


Building.add_type(Quarry, 'industry', 3)


class Quarrying(Job):
    def __init__(self, quarry):
        super(Quarrying, self).__init__(quarry)
    
    def title(self):
        return 'Mason'
    
    def color(self):
        return Color(128, 128, 128)
    
    def body_weight(self):
        return 1
    
    def mind_weight(self):
        return 0
    
    def spirit_weight(self):
        return 0
    
    def work_done(self):
        if self.person().tile().terrain().__class__ is MarbleRock:
            self.spawn(Marble, 0, 2)
        else:
            self.spawn(Stone, 2, 4)
    
    def work_speed(self):
        return 0.0025
