'''Growing and processing grapes.'''

from river.building import *
from river.actions.jobs import *
from river.goods import *


class Vineyard(Building):
    def __init__(self, city, tile):
        super(Vineyard, self).__init__(city, tile, [GrapeVinter(self),
                                                    GrapeVinter(self)])
    
    @classmethod
    def name(cls):
        return 'Vineyard'
        
    @classmethod
    def size(self):
        return 2
    
    @classmethod
    def cost(self):
        return [Wood(7)]
    
    @classmethod
    def color(self):
        return Color(210, 156, 255)


Building.add_type(Vineyard, 'processing', 1)


class GrapeVinter(Job):
    def __init__(self, vineyard):
        super(GrapeVinter, self).__init__(vineyard)
    
    def title(self):
        return 'Vinter'
    
    def color(self):
        return Color(200, 64, 255)
    
    def body_weight(self):
        return 2
    
    def mind_weight(self):
        return 3
    
    def spirit_weight(self):
        return 0
    
    def work_done(self):
        self.spawn(Grapes, 0, 4)
    
    def work_speed(self):
        return 0.001


class Winery(ProcessingBuilding):
    def __init__(self, city, tile):
        super(Winery, self).__init__(city, tile, [Vinter(self)], [Grapes(10)])
    
    @classmethod
    def name(cls):
        return 'Winery'
        
    @classmethod
    def size(self):
        return 2
    
    @classmethod
    def cost(self):
        return [Wood(10), Stone(15)]
    
    @classmethod
    def color(self):
        return Color(200, 64, 255)


Building.add_type(Winery, 'processing', 2)


class Vinter(ProcessingJob):
    def __init__(self, winery):
        super(Vinter, self).__init__(winery)
    
    def title(self):
        return 'Vinter'
    
    def color(self):
        return Color(200, 64, 255)
    
    def body_weight(self):
        return 2
    
    def mind_weight(self):
        return 3
    
    def spirit_weight(self):
        return 0
    
    def work_completly_done(self):
        self.spawn(Wine, 1, 3)
    
    def base_work_speed(self):
        return 0.005
