'''Poor drunken god :-('''

from river.scenario import *

from battle import *


class Despair(Scenario):        
    @classmethod
    def name(cls):
        return 'The Middle'
    
    @classmethod
    def next_scenario(cls):
        return Battle

    def city_name(self):
        return 'Isle of Despair'
    
    def starting_tile(self):
        return self.map().tile(17, 0)
    
    def layout(self):
        return ['$$$=$$$$$$=$$$$$=r$=$$=$~~~~~.$$$$$$=$$$$$$$$$$$$$',
                '$$$$$$$=$$$$$$=$$r$$$..~~~~~~~...$$$$$$$$$$$$=$$$$',
                '$$$$$$$$$$$$=$$$.rr$..~~~~~~~~~.....$$$=$$$$$$$$$$',
                '$$=$$$*%%~~~~~...$rr~~~~~~~~~~~~~..$$$$$$$$$$$$$=$',
                '$$$$$%%~~~~~~~~...~~~~~~~~~~~~~~~~~~...$$$$$=$$$$$',
                '$$$$%*~~~~~~~~~~~~~~~~........~~~~~~~~~~...$$$$$$$',
                '$=%%%~~~~...~~~~~~~~~...........~~~~~~~~~~~~~..$$$',
                '$%%~~~~~......~~~~~~...............~~~~~~~~~~~~~~.',
                '$%~~~~~...................................~~~~~~~~',
                '%%%~~~~~...................................~~~~~~~',
                '%*%%.~~~~~......................~~~~~~~.......~~~~',
                '%%%*%~~~~~~~..................~~~~~~~~~~~....~~~~~',
                '%.~~~~~~~~~~~................~~~~~...~~~~...~~~~~.',
                '%~~~~~~~~~~~.................~~~~..$$$~~~~~~~~~~~$',
                '*~~~~.........................~~~~$$=$$~~~~~~~~~.$',
                '%~~~~~~~.......................~~~~.$$$$.~~~~~.$$$',
                '%.~~~~~~~~~~~~..................~~~~..$$=$$$$$=$$$',
                '%%..~~~~~~~~~~~~.................~~~~~~~~~..$$$$$$',
                '%%%%%%%%..~~~~~~.....~~~~~~~......~~~~~~~~~~.$$$$$',
                '%%%%*%%%%..~~~~~...~~~~~~~~~~~~~....~~~~~~~~~$$$=$',
                '%%%%%%%%...~~~~.....~~~~~~~~~~~~~~~.......~~~~$$$$',
                '*%%%%%%...~~~........~~~~~%%%*~~~~~~~~~~..~~~~$$$$',
                '%%%%%%*%~~~~~~........~~~~~~%%%++~~~~~~~~~~~~$$$$$',
                '%%%%%%%~~~~~~...........~~~~~~~++++~~~~~~~~~$$$$$$',
                '%%%%%.~~~~~................~~~~~++%*%%%%~~~$$$=$$$',
                '%%*%.~~~~~....................~~~~%%%%%%%%$$$$$$$$',
                '%%%%%~~~~......................~~~~%%%*%%$$$$$$$$$',
                '%%%%.~~~~.......................~~~%%%%$$$$$$$$$$$',
                '%%%%..~~~~......................~~~$$$$$$$=$$$$=$$',
                '%*%%$$$~~~~......................~~~$$$$$$$$$$$$$$',
                '%%%%$$$$~~~~~.....................~~~$$$$$$$=$$$$$',
                '%%$$$$=$..~~~~~...................~~~~$$$$$$$$$$$$',
                '$$$$$$$$$...~~~~.....~~~~~.........~~~~$$$$$$$$$$$',
                '$$$$=$$$$$$...~~~~..~~~~~~~~......~~~$$$$$$$$$$$$$',
                '$$$$$$$$=$$$$$$~~~~~~~~~~~~~~~..~~~~$$$=$$$$$$=$$$',
                '$$=$$$$$$$$$$$$$~~~~~.$$=$$$~~~~~~~$$$$$$$$$$$$$$$',
                '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$~~~~~~$$$$$$$$$$$$$$$',
                '$$$$$=$$$$=$$$$$$$$$=$$$$$$~~~~~~~$$$$$$$$$=$$$$$$',
                '$$$$$$$$$$$$$$$=$$$$$$$$.~~~~~.$$$$$$$$$$$$$$$$$$$']

    def setup(self):
        for x in [Road, Bridge, Plaza, Storage, House, Farm, Sawmill, Quarry,
                  Vineyard, Winery]:
            self.allow(x)
            
        self.create_immigrants(4)
        
    def intro(self):
        self.flavor(['"Oh, what a pretty isle!" "And so suitable for farming!" "And that',
                     'silly god is nowhere in sight!"'])
        self.flavor(['"He prolly got a hangover!" The responses to your proposed camp site',
                     'were very positive. After all, you all grew up'])
        self.flavor(['on an isle. "Ooooh, there\'s marble here! Let\'s quarry some"'])
        
        self.objective(['Quarry some marble.'])
        
    def script(self):
        total_p     = lambda: len(self.city().persons())
        number_of_p = lambda x: len(self.city().persons_of_type(x))
        number_of_b = lambda x: len(self.city().buildings_of_type(x))
        number_of_r = lambda x: self.city().resources_of_type(x)
        number_of_h = lambda: len(self.city().persons_with(lambda x: x.happiness().is_happy()))
        
        return [(lambda: number_of_r(Marble)    >=   1, self.on_marble      ),
                (lambda: number_of_b(School)    ==   1, self.on_school      ),
                (lambda: number_of_h()          >=  15, self.on_done        )]
        
    def on_marble(self):
        self.allow(School)
        
        name = random.choice(list(self.city().persons())).name()

        self.message(['Ooooooh, that rock is pretty!'])
        self.flavor(['"Marble, that reminds me of my old school... We built that '
                     'completly out of marble!", %s says.' % name])
        self.flavor(['"A school! What a good idea. Teaching each other will allow ',
                     'us to become much more effective!", you remark.'])

        self.objective(['Build a school.'])
        
    def on_school(self):
        self.message(['The new school invites everyone to share their knowledge!'])
        self.flavor(['"Class dismissed!" The first lesson in your new school just came to an ',
                     'end. "Hello." You turn around. And see her.'])
        self.flavor(['She seems to be completely made out of water! "I\'m Aqua.", she says. ',
                     '"You are the followers of the cruel one?"'])
        self.flavor(['"Well, yes.", you say, "But we had to. And we are not like him. ',
                     'We just want to be happy!" She nods and dissolves.'])
        
        self.objective(['Have at least 15 people with happiness 75% or more.'])
        
    def on_done(self):
        self.message(['Your people like this village!'])
        self.flavor(['Aqua emerges from the river. "Indeed you speak the truth. ',
                     '"I\'ll help you! You -- I feel him. He should not see me!"'])
        self.flavor(['Suddenly she is gone. Shortly after that, a dark cloud appears. '
                     '"AAAAH, MY BRAIN! YOU DID THAT! YOU GAVE'])
        self.flavor(['ME THAT WINE!!! FEEL MY WRATH!" "But you wanted--" "BAH! ABANDON ',
                     'THIS VILLAGE AND FOLLOW ME!"'])
        
        self.objective(['You win!'])        
        self.win()
    