'''The god wants to get drunk.'''

from river.scenario import *

from despair import *


class Diwine(Scenario):        
    @classmethod
    def name(cls):
        return 'The Beginning'
    
    @classmethod
    def next_scenario(cls):
        return Despair

    def city_name(self):
        return 'Diwine Fields'
    
    def starting_tile(self):
        return self.map().tile(49, 37)
    
    def layout(self):
        return ['$$$$$$$$$=$$$$$$...........;......................',
                '$$=$$$$$$$$$$......;....................;.........',
                '$$$$$.$$$$$..............~~~~~~....;..............',
                '$$$~....$$$$............~~~~~~~~~...........~~~~~~',
                '$$$$..............;...~~~~~~~~~~~~~~....~~~~~~~~~~',
                '$$=$$$......;........~~~~~~...~~~~~~~~~~~~~~~~~~~~',
                '$$$$$$...............~~~~~~~~...~~~~~~~~~~~~~.....',
                '$$.$$..................~~~~~~~~....~~~~~~~....~~~.',
                '$.........;...;............~~~~~~~.........~~~~~~~',
                '..................;...........~~~~~~~~~~~~~~~~~~~~',
                '.......;................;........~~~~~~~~~~~..~~~~',
                '...........;........................~~~~~~~..~~~~~',
                '.....;.............;........................~~~~~.',
                '........................~~~~~~~~~~~~.....~~~~~~~~.',
                '......;....~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~..',
                '..;......~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~....',
                '........~~~~~~.~~~~~~~~~~~........~~~~~~~~~.......',
                '........~~~~....................................%%',
                '........~~~~~~.......~~~~~~~..................*%%%',
                '..........~~~~~....~~~~~~~~~~~~~............%%%%%*',
                '...;.......~~~~.....~~~~~~~~~~~~~~~........%%%%*%%',
                '..........~~~~.......~~~~~...~~~~~~~~~~~.%%*%%%%%%',
                '........~~~~~~......~~~~~~~~....~~~~~~~~~~~~%%%~~~',
                '.......~~~~~~......~~~~~~~~~~~~..~~~~~~~~~~~~~~~~~',
                '.;...~~~~~~~~~~.~~~~~~.....~~~~~~~~~~%%%~~~~~~~~~~',
                '...~~~~~~~~~~~~~~~~~~...$$....~~~~~~%%%%%*~~~~~~%%',
                '..~~~~~~~..~~~~~~~~~...$$$$...$$$%*%%%*%%%%%%%%*%%',
                '.~~~~~...$$$~~~~~~....$$$$$$$$=$$$$%%%%%%%%*%%%%%%',
                '~~~~~..$$$$$$$.........$=$$$$$$$$$$$%%%%%%$$$$$%*%',
                '~~~~$$$$$=$$$........$$$$$$$$$$$$$$$*$$=$$$$$$$$$$',
                '~~~.$$$$$$$$$$$$...$$$$$$$$$$$$=$$$$$$$$$$$$$$$$$$',
                '..$$$$$$...$$$$$$$$$$$$$.....$$$$$$$$$$$$$$$$$=$$$',
                '$$$$$$......$$$$=$$$$$........$$$$$$.$$$$$$$$$$$$$',
                '$$$=$$$.......$$$$$$$......$$$$$.$$...$.....$$$...',
                '$$$$$$$$...$$$$$$$$$$$$$..$$=$$$$$..............rr',
                '$$$$$$$$$$$$$$$=$$$$$.$$$$$$$$$$$$$......$.$..$.$.',
                '$$$$$$$$$=$$$$$$$$$$$$$$$...$$$$$$$$....$...$$$...',
                '$$=$$$$$$$$$=$$$$$$$=$$$.....$$$$=$$$$$...$.$...$.',
                '$$$$$$$$$$$$$$$$$$$$$$$$.......$$$$$$...$.....$...']

    def setup(self):
        for x in [Road, Bridge, Plaza, House, Farm, Sawmill, Quarry]:
            self.allow(x)
            
        self.create_immigrants(4)
        
    def intro(self):
        self.flavor(['"SO YOU HOLD YOUR PROMISE?" You shudder at his voice. "Yes. Leave the ',
                     'isle alone and I will do your quests!"'])
        self.flavor(['"GOOD! YOU SEE THIS MEADOW TO THE NORTH? GRAPES GROW THERE! ',
                     'I WANT WINE! MAKE ME SOME!!!"'])
        self.flavor(['"We first need to build a village and attract workers ',
                     'to grow and harvest them." "DO THAT!" Then he was gone.'])
        self.objective(['Become a nice small village with 10 inhabitants.'])
        
    def script(self):
        total_p     = lambda: len(self.city().persons())
        number_of_p = lambda x: len(self.city().persons_of_type(x))
        number_of_b = lambda x: len(self.city().buildings_of_type(x))
        number_of_r = lambda x: self.city().resources_of_type(x)
        
        return [(lambda: total_p()              ==  10, self.on_village     ),
                (lambda: number_of_r(Wine)      >=   1, self.on_wine        ),
                (lambda: number_of_r(Wine)      >= 100, self.on_done        )]
        
    def on_village(self):
        self.allow(Vineyard)
        self.allow(Winery)
        self.allow(Storage)
        
        name = random.choice(list(self.city().persons())).name()

        self.message(['Well done! Your villages grew into a small town.'])
        self.flavor(['"With the latest immigrants, we should now have enough workers '
                     'to start growing wine", %s says.' % name])
        
        self.objective(['Make some wine.'])
        self.hint(['Build a wine industry on the meadow with the grapes. Build ',
                   'houses for the workers up there, too.'])
        self.hint(['Use storage buildings to minimize the way your workers have ',
                   'to run.'])
        
    def on_wine(self):
        name = random.choice(list(self.city().persons())).name()

        self.message(['You made some wine!'])
        self.flavor(['"Ahh!", you exclaim after taking your first sip of wine ',
                     'in a long time. "Wonderful! He will love that!"'])
        self.flavor(['"This wine really raises our spirits!", %s says. Suddenly, ' % name,
                     'a dark cloud appears.'])
        self.flavor(['"YOU MADE WINE! GOOD! NOW GO MAKE ME 100 OF IT!"'])
        
        self.objective(['Make at least 100 wine.'])
    
    def on_done(self):
        self.city().destroy_resource(Wine)
        
        name = random.choice(list(self.city().persons())).name()

        self.message(['Great! Now you\'re the follower of a drunken god!'])
        self.flavor(['"WIIIINE!!!!" The sky darkens, and suddenly all your wine ',
                     'is gone. "IT IS MINE!!!!"'])
        self.flavor(['"He is gone.", %s says. "For now. It is time for us to move on, too.", ' % name,
                     'you reply.'])
        
        self.objective(['You win!'])        
        self.win()
    