'''The unlimited play scenario.'''

from river.scenario import *


class FreePlay(Scenario):    
    @classmethod
    def name(cls):
        return 'Free Play'

    def city_name(self):
        return 'Twistania Mountains'
    
    def starting_tile(self):
        return self.map().tile(16, 0)
    
    def layout(self):
        return ['=$$$=$$=$.:.....r.""."~~~~~~~~~~~~~~~~~~$$$$$$$$$$',
                '$=$$$$$.........r"."~~~~~~~~~~~......~~~~$$$$=$$$$',
                '$$$$=..~~~~.:....""~~~~~~.............~~~~.$$$$$$$',
                '=$$...~~~~~~~~..."~~~~~~..............####...$$$$$',
                '$$=.~~~~~~~~~~~~~~~~~~~...............####..$$$$$$',
                '=$~~~~~...~~~~~~~~~~~~................####.$$$$=$$',
                '$~~~~~.....~~~~~~~~~~.................####..$$$$$$',
                '$~~~~........~~~~~~~.................~~~~~...$$$$$',
                '~~~~..................~~~~~~.......~~~~~~....$=$$$',
                '~~~~........~~~~~~~~~~~~~~~~~~....~~~~~....$$$$$$$',
                '~~~......~~~~~~~~~~~~~~~~~~~~~...~~~~.....$$$$$$$$',
                '~~.....~~~~~~~~...~~~~~~~~~~~~.!!~~~~......$$$$=$$',
                '~.....~~~~~......~~~.~~~~~~~~~!!!!~~~~~...$$$$$$$$',
                '%...~~~~~......~~~~...!~~~~~!!!!!!!.~~~~~$$=$$$$$$',
                '%%%~~~~.......~~~...!!!!!!!!!!!!!!....~~~~~$$$$=$$',
                '*%%~~~~%.....~~~~..!!!!!!!~~~~~~~....=$$~~~~~$$$$$',
                '%%%####%.....~~~~!!!!!!!!~~~~~~~~~~~$$$$~~~~~~~$$$',
                '%%%####%*.....~~~~~~~~~~~~~~~...~~~~~~~~~^^^~~~~!!',
                '%%%####%%%.....~~~~~~~~~~~~~.....~~~~~~~^^^~~~~!!!',
                '%*%~~~~%%.......^^^^^^^^^^^........$$$$^^^^~~~!!!!',
                '%%%%~~~~.......^^^^^^^^^^^^......$$=$$^^^^^###!!!!',
                '%%....~~~~.....^^^^^^^^^^^^^....$$$$$$^^^^^###!!!!',
                '........~~~~....^^^^~~~~^^^^^....$$$$$$^^^^###!!!!',
                '..........~~~~..^^~~~~~~~~^^^^^..$$$$=$$^^^###!!!!',
                '............~~~~~~~~~^^^~~~~^^^^.$$$$$$^^^~~~!!!!!',
                '.............~~~~~~^^^^^^^~~~~^^$$$$$$$^^~~~!!!!!!',
                '................^^^^^^^^^^^~~~~$$$$=$$^^^~~~!!!!!!',
                '................^^^^^^^^^^^^^~~~~$$$$^^^^^~~~!!!!!',
                '..........~~~~~~~^^^^^^^^^^^^~~~~~~^^^^^^^^~~~~!!!',
                '.........~~~~~~~~~~^^^^^^^^~~~~~^~~~~^^^^^^^^~~~~~',
                '.......~~~~~..^~~~~~^^^^^~~~~~^^^^^~~~~^^^^^^^^~~~',
                '.....~~~~~...^^^^^~~~~~~~~~~~^^^^^^^~~~~^^^^%*%%++',
                '...~~~~~~..^^^^^^^^~~~~~~~~^^^^^^^^^^~~~^^^%%%%+++',
                '~~~~~~~~...^^^^^^^^^^^^^^^^^^^^^^^^^^~~~~^%*%%++++',
                '~~~~~~~...^^^$$$$=^^^^^^^^^^^^^...^^^^~~~~%%%++++%',
                '~~~~.......$$$=$$$$$^^^^^^^^.......^^^^~~~~++++%*%',
                '.............$$$$$^^^^^^^^^^........^^^^~~~+++%%%%',
                '...............^^^^^^^^^^..........^^^^^~~~%%%*%%%',
                '.........^^^^^^^^^^^^^^.............^^^^^~~~%%%%%%']
        
    def intro(self):
        self.flavor(['At the foot of this big mountain range, an abundance of ',
                     'resources await your villagers.'])
        self.flavor(['The spirits are high and not even your twisted god ',
                     'dares to demand quests from you.'])
        self.flavor(['If you build enough houses, immigrants will come ',
                     'and join your village!'])
        
        self.objective(['Have fun!'])
        